/*
 * Copyright 2024 Luca Fulchir <luca.fulchir@runesauth.com>
 *
 * Licensed under the Apache License, Version 2.0 with LLVM exception (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License and of the exception at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *     https://spdx.org/licenses/LLVM-exception.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

use ::std::any::Any;

// Package stuff

#[macro_export]
macro_rules! moduse {
    ($($name:ident)*) => {
        $(
            mod $name;
            #[allow(unused_imports)]
            use $name::*;
        )*
    };
}
pub use moduse;

pub trait PkgsList {}

///
/// This is an empty Package List. Will be available in the main library
///
#[derive(::std::default::Default)]
pub struct PkgsEmpty {}
impl PkgsList for PkgsEmpty {}

pub trait Pkg: Any {
    fn as_any(&self) -> &dyn Any
    where
        Self: Sized,
    {
        self
    }
}

// Conf stuff
/*
pub struct Conf {}

pub enum Value<T: Sized> {
    /// Set, only once per
    Set(T),
    /// Delete a value
    Del(T),
}
pub enum ValueList<T: Sized> {
    /// Set, only once per
    Set(T),
    /// Delete a value
    Del(T),
    /// Add to a list
    Add(T),
    /// Merge (add + dedup)
    Merge(T),
}
*/
